#include <stdio.h>
#include <stdlib.h>

const int screen_left = 0;
const int screen_right = 320;
const int screen_top = 10;
const int screen_bottom = 190;

#include "sprite.h"
#include "bullet.h"
#include "ship.h"
#include "enemy.h"
#include "player.h"

int sign(int a);

Enemy::Enemy()
		{
			bitmap = NULL; explosion = NULL; bullet = NULL;
			x = 0; y = 0;
			dx = 0; dy = 0;
			bullets = NULL;
			state = 0;
			fire_rate =0;
			type = 0;
			max_hits = hits = 0;
		}

void
Enemy::Init(Sprite* bm, Sprite* expl, Sprite* bullt, int start_x, int start_y,int t,int hit)
		{
			bitmap = bm; explosion = expl; bullet = bullt;
			x = start_x; y = start_y;
			dx = 0; dy = 0;
			bullets = NULL;
			state = 1;
			fire_rate =20;
			type = t;
			max_hits = hits = hit;
		}

void
Enemy::move()
		{
			if(state)
			{
				x+=dx;	y+=dy;

				if(x > (enemy_boundary_right-bitmap->sx))
				{
					x = enemy_boundary_left+random(abs(dx));
				}
				if(x < enemy_boundary_left)
				{
					x = (enemy_boundary_right-bitmap->sx) - random(abs(dx));
				}
				if(y > (enemy_boundary_bottom-bitmap->sy))
				{
					y = enemy_boundary_bottom-bitmap->sy;
				}
				if(y < enemy_boundary_top)
				{
					y = enemy_boundary_top;
				}
			}
		}

void Enemy::update( Player &player, Sprite &city, Sprite &city_death, Sprite &city_explosion, byte *screen)
{
	int i;
	Bullet *temp, *current, *last;
	int deleted = 0;
	int xx,yy;

	draw(screen);

	move();

	if(fire_rate==-1 && state==1)		//death ray !
	{

		temp = new Bullet(x+(bitmap->sx/2), y+bitmap->sy,
								dx, 5, bullet);

		if(temp)
		{
			temp->next = bullets;
			bullets = temp;
		}

		dx += random(3) -1;

		if(dx>10) dx = 10;
		else if(dx<-10) dx = -10;
	}
	else if(!random(fire_rate) && state==1) // enemy fires
	{
		temp = new Bullet(x+(bitmap->sx/2), y+bitmap->sy,
								dx/2, random(5)+3, bullet);

		if(temp)
		{
			temp->next = bullets;
			bullets = temp;
		}
	}


	if(state==2)		// exploding
	{
/*		if(type==5)
		{

		}
		else
		{
*/			player.score+= (13-(fire_rate/2))*5*max_hits;
			state = 1;
			hits = max_hits;
			x = enemy_boundary_left;
			y = random(enemy_boundary_bottom - enemy_boundary_top)+enemy_boundary_top;
			dx = sign(dx)*(random(5)+3);

			if(!random (25) && type==1)
				fire_rate = -1;
			else
				fire_rate = random(25);
//		}
	}


	last = current = bullets;
	while(current)
	{
		deleted = 0;

		current->draw(screen);
		current->move();

		// check for collisions
		if(player.isHit(current))
		{
			player.shield -= 13;
			player.shield_sprite->draw( player.x + ((player.bitmap->sx - player.shield_sprite->sx) /2),
												 player.y - 10, screen);
			city_explosion.draw(current->x - city_explosion.sx/2 + current->bitmap->sx,
											current->y + current->bitmap->sy - city_explosion.sy/2, screen);

			if(player.shield<0)
			{
				player.state=2;

				player.x -= (player.explosion->sx - player.bitmap->sx)/2;
  //					player.y -= (player.explosion->sy - player.bitmap->sy)/2;
			}

				// remove bullet
			if(bullets == current) 	// first in list
			{
				bullets = current->next;

			}
			else
			{
				last->next = current->next;
			}

			temp = current;
			current = current->next;
			delete  temp ;
			deleted = 1;
			continue;		// skip to top of loop
		}

			// check if hit a building
		if((current->y) > (screen_bottom-city.sy)  && current->x>0 && current->x<320)
		{
			for(yy=0;yy<current->bitmap->sy;yy++)
				for(xx=0;xx<current->bitmap->sx;xx++)
				{
						// hit a pixel?
					if(city.bitmap[current->x+xx + (current->y-(screen_bottom-city.sy)+yy)*city.sx]
						&& current->bitmap->bitmap[xx+yy*current->bitmap->sx])
					{


						city_explosion.draw(current->x + xx - city_explosion.sx/2,
											current->y + yy - city_explosion.sy/2, screen);

						eraseCity( city, city_death,
										current->x + xx - city_death.sx/2,
										current->y - (screen_bottom - city.sy) + yy - city_death.sy/2 );


						deleted = 1;
						xx = current->bitmap->sx;
						yy = current->bitmap->sy;

					}

				}

			if(deleted)
			{
				if(bullets == current) 	// first in list
				{
					bullets = current->next;

				} else
				{
					last->next = current->next;
				}

				temp = current;
				current = current->next;
				delete temp ;
				deleted = 1;
				continue;
			// last stays the same
			}

		}

			// out of screen?
		if(current->x >= (enemy_boundary_right-current->bitmap->sx - current->dx)
			|| current->x <= enemy_boundary_left + (current->bitmap->sx+current->dx)
			|| current->y >= (screen_bottom-current->bitmap->sy - current->dy)
			|| current->y <= (current->bitmap->sy+current->dy))		// remove bullet from list
		{
			if(bullets == current) 	// first in list
			{
				bullets = current->next;

			} else
			{
				last->next = current->next;
			}

			temp = current;
			current = current->next;
			delete  temp ;
			deleted = 1;
			continue;
		// last stays the same
		}

		if(!deleted)
		{
			last = current;
			current= current->next;
		}
	}
}

int sign(int a)
{
	if(a<0) return -1;
	if(a) return 1;
	return 0;
}





