#include <stdio.h>
#include <string.h>
#include <dos.h>

#include "sprite.h"

//unsigned char far * vga = (unsigned char far * ) MK_FP(0xa000,0);

const int enemy_boundary_top = 20;
const int enemy_boundary_bottom = 120;
const int enemy_boundary_left = -80;
const int enemy_boundary_right = 400;
const int screen_left = 0;
const int screen_right = 320;
const int screen_top = 10;
const int screen_bottom = 190;

void go256()
{
	asm mov ax, 0013h
	asm int 10h

		// put into 'letter box' mode
		// 320x200x256 square pixels
		// 60hz
//	asm mov al, 0e3h
//	asm mov dx, 3c2h
//	asm out dx,ax
}

void textmode()
{
	asm mov ax, 0003h
	asm int 10h
}

void clrscreen( byte * addr, unsigned char colour)
{
asm .386

asm push ds
asm lds si, addr

asm mov cx, 16000

asm mov bl, colour
asm mov al,bl
asm shl eax, 8
asm mov al, bl
asm shl eax, 8
asm mov al,bl
asm shl eax, 8
asm mov al,bl

loop:

asm rep stosd

asm pop ds


}
void flip( char far *src, char far *dest)
{
	asm {
		.386

		push ds
		mov cx, 16000        		// 16000 32bit dwords to copy/clear
		lds si, src						// set up ds:si & es:di
		les di, dest
	}
	loop1:
	asm {
		mov eax, [ds:si]				// copy source pixels (4) to dest
		mov [es:di], eax

		add di, 4						// move pointers along one dword
		add si, 4

		dec cx							// counter --

		jnz loop1

		pop ds
	}

}

void flipAndClear( char far *src, char far *dest,  byte colour)
{
	asm {
		.386

		push ds
		mov cx, 16000        		// 16000 32bit dwords to copy/clear
		lds si, src						// set up ds:si & es:di
		les di, dest
		mov dl, byte ptr colour		// copy colour into all 4 bytes of
		mov bl, dl						// ebx
		shl ebx, 8
		mov bl, dl
		shl ebx, 8
		mov bl, dl
		shl ebx, 8
		mov bl, dl
	}
	loop1:
	asm {
		mov eax, [ds:si]				// copy source pixels (4) to dest
		mov [es:di], eax
		mov [ds:si], ebx				// clear source to colour

		add di, 4						// move pointers along one dword
		add si, 4

		dec cx							// counter --

		jnz loop1

		pop ds
	}
}


void waitForRetrace()
{

asm mov dx,3DAh
l1:
asm in al,dx
asm and al,08h
asm jz l1
l2:
asm in al,dx
asm and al,08h
asm jnz  l2

//	while( ! (inportb(0x3da)&0x8));		// while bit 3 is 0
//	while( (inportb(0x3da)&0x8));			// while bit 3 is 1

	// wait for bit 3 to turn zero...
}


	// constructor
/*byte *
loadSprite( char *filename, int &sx, int &sy)	// loads sprite from filename,
																// stores size in sx & sy
																// returns a pointer to the
																// bitmap
{
	FILE * fp;
	byte *temp;

	fp = fopen(filename, "rb");
	if(fp==NULL)
	{
		sx = 0;
		sy = 0;
		return NULL;
	}

	rewind(fp);

	sx = fgetc(fp) + (fgetc(fp)<<8) + 1;
	sy = fgetc(fp) + (fgetc(fp)<<8) + 1;


	temp = new byte [sx*sy];
	if(temp ==NULL)
	{
		sx = 0;
		sy = 0;
		return NULL;
	}

	if(!fread(temp ,1,sx*sy,fp))
	{
		delete [] temp;
		temp = NULL;
		sx = 0;
		sy = 0;
	}

	fclose(fp);

	return temp;
} */

byte *
loadSprite( FILE* datafile, int &sx, int &sy)	// loads sprite from filename,
																// stores size in sx & sy
																// returns a pointer to the
																// bitmap
{
	byte *temp;

	sx = fgetc(datafile) + (fgetc(datafile)<<8) + 1;
	sy = fgetc(datafile) + (fgetc(datafile)<<8) + 1;


	temp = new byte [sx*sy];
	if(temp ==NULL)
	{
		sx = 0;
		sy = 0;
		return NULL;
	}

	if(!fread(temp ,1,sx*sy,datafile))
	{
		delete [] temp;
		temp = NULL;
		sx = 0;
		sy = 0;
	}

	return temp;
}

void
copySprite( int x, int y, byte *bitmap, int sx, int sy, byte *screen)
										// draws a sprite to the screen, without
										// transparency
{
	if(!bitmap || !sx || !sy) return;

	asm {      		// 32bit version, 15.015 fps 200x(40x40) blobs
		.386
		push ds

		lds si, bitmap					// set up ds:si & es:di to point to
		les di, screen 				// the image & bitmap

		mov ax, y						// make di = di + 320*y + x
		imul ax, 320					// ie go to the correct coordinates
		add ax, x

		add di, ax

		mov cx,sx						// start y at sx, start x at sx
		shr cx, 2						// copy 4 bytes at a time
		mov dx,sy
	}
	loopi:
	asm {
		rep movsd 						// copy dest pixel to source pixel

		mov cx,sx						// reset i counter
		shr cx, 2						// copy 4 bytes at a time

		add di, 320						// move es down a line and back to start of
		sub di, sx	 					// x strip

		dec dx							// decrement j counter
		jnz loopi

		pop ds
	}
}
void gputs(int col, int row, const char * str, Sprite &font, byte *screen)
{
	byte c;
	int i;
	int l = strlen(str);
	int x, y;

	col *=8;
	row *=8;

	for(y=0;y<8;y++)
	{
		for(i=0;i<l;i++)
		{
			for(x=0;x<8;x++)
			{
				c = font.bitmap[((str[i]-32)%16)*8 + x + (((str[i]-32)/16)*8 + y)*font.sx];
				if(c)
				{
					putPixel(col + i*8 + x, row + y, c, screen);
				}
				else
				{
					putPixel(col + i*8 + x, row + y, 0, screen);
            }

			}
		}
	}
}

void
clipSprite( int x, int y, byte *bitmap, int sx, int sy, byte *screen)
										// draws a sprite to the screen, with colour
										// 0 being transparent.
										// clips it to the screen boundaries as defined
										// by screen_top, screen_bottom,
										// screen_left, screen_right
{
	if(!bitmap || !sx || !sy) return;

	byte c;
	int i, j;
	int draw_x = sx, draw_y = sy;
	int start_x = 0, start_y = 0;

	if( (x+sx) > screen_right)
	{
		if(x>screen_right) return;

		draw_x = screen_right - x;
		start_x = 0;
	}
	else if(x<screen_left)
	{
		if((screen_left-x)>sx) return;

		draw_x = x+sx - screen_left;
		start_x = screen_left-x;
	}

	if( (y+sy) > screen_bottom)
	{
		if(y>screen_bottom) return;

		draw_y = screen_bottom - y;
		start_y = 0;
	}
	else if(y<screen_top)
	{
		if((screen_top-y)>sy) return;

		draw_y = y+sy - screen_top;
		start_y = screen_top-y;
	}

	for(j=0;j<draw_y;j++)
	{
		for(i=0;i<draw_x;i++)
		{
			if(c = bitmap[start_x + i + (start_y + j)*sx])
			{
				putPixel(x + start_x + i, y + start_y + j, c, screen);
			}
		}
	}
}


void
eraseCity( Sprite &city, Sprite &city_death, int x, int y )
{
	if(!city.bitmap || !city_death.bitmap) return;

	byte c;
	int i, j;
	int sx = city_death.sx, sy = city_death.sy;
	int draw_x = sx, draw_y = sy;
	int start_x = 0, start_y = 0;

	if( (x+sx) > city.sx)
	{
		if(x>city.sx) return;

		draw_x = city.sx - x;
		start_x = 0;
	}
	else if(x<0)
	{
		if(x<-sx) return;

		draw_x = x+sx;
		start_x = -x;
	}

	if( (y+sy) > city.sy)
	{
		if(y>city.sy) return;

		draw_y = city.sy - y;
		start_y = 0;
	}
	else if(y<0)
	{
		if(y<-sy) return;

		draw_y = y+sy;
		start_y = -y;
	}

	for(j=0;j<draw_y;j++)
	{
		for(i=0;i<draw_x;i++)
		{
			if(city_death.bitmap[start_x + i + (start_y + j)*sx])
			{
				city.bitmap[x + start_x + i + (y + start_y + j)*city.sx] = 0;
			}
		}
	}
}
