#include <mem.h>
typedef unsigned char byte;
#define setRGB(colour,r,g,b)  {outportb(0x3c8,(colour));outportb(0x3c9,(r));\
										 outportb(0x3c9,(g));outportb(0x3c9,(b));}
#define getRGB(colour,r,g,b)  {outportb(0x3c7,(colour));*(r)=inport(0x3c9);\
										 *(g)=inport(0x3c9);*(b)=inport(0x3c9);}
#define putPixel(x,y,colour,addr)  {*(addr + (x) + ((y)<<8) + ((y)<<6)) = (colour);}
#define getPixel(x,y,addr)  *(addr+(x)+((y)<<8)+((y)<<6))

//byte *
//loadSprite( char *filename, int &sx, int &sy);	// loads sprite from filename,
byte *
loadSprite( FILE* datafile, int &sx, int &sy);	// loads sprite from filename,
																// stores size in sx & sy
																// returns a pointer to the
																// bitmap
void
copySprite( int x, int y, byte *bitmap, int sx, int sy, byte *screen);
										// draws a sprite to the screen, without
										// transparency
void
clipSprite( int x, int y, byte *bitmap, int sx, int sy, byte *screen);
										// draws a sprite to the screen, with colour
										// 0 being transparent.
										// clips it to the screen boundaries as defined
										// by screen_top, screen_bottom,
										// screen_left, screen_right


class Sprite {

	public:
		byte * bitmap;
		int sx, sy;

//		Sprite( char *filename) {	bitmap = loadSprite(filename, sx, sy);	};
		Sprite( char *filename, FILE* datafile) {	bitmap = loadSprite(datafile, sx, sy);	};
																// loads sprite from filename,
																// stores size in sx & sy
																// returns a pointer to the
																// bitmap

		Sprite( Sprite& copyfrom)		// creates a sprite as a copy of another
												// sprite
		{
			sx = copyfrom.sx;
			sy = copyfrom.sy;

			bitmap = new byte [sx*sy];
			if(bitmap)
			{
				memcpy(bitmap, copyfrom.bitmap, sx*sy);
			}
		}

		void
		draw( int x, int y, byte *screen) {	clipSprite(x,y,bitmap, sx,sy, screen);		};
										// draws a sprite to the screen, with colour
										// 0 being transparent.
		void
		copy( int x, int y, byte *screen) {	copySprite(x,y,bitmap, sx,sy, screen);		};
										// draws a sprite to the screen, without
										// transparency

		~Sprite(void) { if(bitmap)
								delete [] bitmap;
							}
};



void go256();
void textmode();
void clrscreen( byte * addr, unsigned char colour);
void flip( char far *src, char far *dest);
void flipAndClear( char far *src, char far *dest,  byte colour);
void waitForRetrace();
void gputs(int col, int row, const char * str, Sprite &font, byte *screen);

void
eraseCity( Sprite &city, Sprite &city_death, int x, int y );
